## Cyber security and machine learning course for security engineers.

 Machine learning is used in various services/products, and is also used in cyber security field. The aim of this blog is **for cyber security engineers** to learn machine learning use cases in cyber security field and vulnerabilities of machine learning.  

 **[Japanese version is here](./README.md)**  

### Defensive part
 1. Intrusion detection (Logistic Regression).  
 2. Spam detection (Naive Bayes).  
 3. Anomaly detection (K Nearest Neighbor).  
 4. Attack detection (K means Clustering).  
 5. Trend analysis of vulnerability (Topic model).  
 6. Attack's payload recommendation (Multi-Layer perceptron).  
 7. Face authentication (Convolutional Neural Network).  

 The defensive part is to learn the basics of machine learning using machine learning use cases in the cyber security field.  

### Offensive part
 1. Stealing model (Model extraction).  
 2. Bypassing Spam detection (Data poisoning).  
 3. Bypassing Face recognition (Adversarial Examples).  
 4. Deceiving Voice recognition (Audio Adversarial Examples).  
 5. Backdooring (Neural trojan).  
 6. Malware concealment (DeepLocker).  
 7. Video scam (DeepFake).  
 8. Voice scam (Audio DeepFake).  

 The offensive part is to learn the vulnerabilities of machine learning model and countermeasures.  

 This blog is a **foundamental training course for machine learning**, so I don't use mathematical formulas to explain machine learning algorithms. But I use simple sample code, so **you can learn machine learning algorithms with hands-on**. If you want to learn more about the theory, read other blogs/papers.  

### CHANGELOG
None.  
